﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Xml;
using System.Xml.Linq;

namespace Prevodnik_jednotiek
{
    public class XML
    {
        private string XmlPath = @"../../../data.xml";

        private XmlDocument xmlDocument;
        private static XML instance;
        public XML()
        {
            xmlDocument = new XmlDocument();
            xmlDocument.Load(XmlPath);
            
        }

        /*Ziskame data pre jazyky*/
        public List<string> getDataForLanguage(string language)
        {
            List<string> data = new List<string>();
            XmlNode MyNode = xmlDocument.SelectSingleNode("converter/languages/"+language);

            int count = MyNode.ChildNodes.Count;
            for (int j = 0; j < count;j++ )
            {
                var items = MyNode.ChildNodes[j].ChildNodes;
                for (int i = 0; i < items.Count; i++)
                {
                    data.Add(items[i].InnerText);
                }
            }
                
        
                return data;
        }

        /*Ziskame data pre jednotky*/
        public List<string> getDataForUnits(string category)
        {
            List<String> data = new List<string>();
            XmlNode MyNode = xmlDocument.SelectSingleNode("converter/units/" + category);
            int count = MyNode.ChildNodes.Count;
            for (int j = 0; j < count; j++)
            {
                var items = MyNode.ChildNodes[j].ChildNodes;
                for (int i = 0; i < items.Count; i++)
                {
                    data.Add(items[i].InnerText);
                }
            }

            return data;
        }

        
        /*Lazy Load pattern*/
        public static XML Instance()
        {
            if (instance == null)
            {
                instance = new XML();
            }

            return instance;
        }
    }
}
